plugins['queuepausedcounter'] = (function() {

    var min_available_threshold = pluginconfig['queuepausedcounter']['min_available_threshold'][''];
    var max_paused_threshold    = pluginconfig['queuepausedcounter']['max_paused_threshold'][''];
    if(pluginconfig['queuepausedcounter']['ignore_invalid_agents']===undefined) { pluginconfig['queuepausedcounter']['ignore_invalid_agents']={}; }
    if(pluginconfig['queuepausedcounter']['ignore_invalid_agents']['']===undefined) { pluginconfig['queuepausedcounter']['ignore_invalid_agents']['']=0; }
    var ignore_invalid_agents   = pluginconfig['queuepausedcounter']['ignore_invalid_agents'][''];

    clearInterval(window.queuepausedcounterinterval);
    window.queuepausedcounterinterval=setInterval(function(){plugins['queuepausedcounter'].updategraph();},500);

    if(typeof window.dataqueuepausedcounter == 'undefined') {
        window.dataqueuepausedcounter = new Array();
    }

    var countreason      = {}; 
    var currentpaused    = 0;
    var currenttotal     = 0;
    var currentavailable = 0;
    var plot;
    var maxy = 5;
    var lastsecond = -1;

    return { 

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~queuepausedcounter" + "|" + hash + "\" />";
            sendcommand();
        },
        setLang: function() {
            if($('#queuepausedcountTitle').length>0) {
                debug('set lang queuepausedcounter');
                $('#queuepausedcountTitle').html(lang.queuepausedcounter);
                $('#box_queuepausedcounterbox .langcollapse').attr('data-original-title',lang.collapse);
                $('#box_queuepausedcounterbox .langlockunlock').attr('data-original-title',lang.toggle_lock);
            }
        },
        init: function() {
            // initialization function
        },
        updategraph: function() {

            if ($('#box_asternicTagbox').length > 0) {
                return;
            }

            if(typeof plot != 'undefined') {
                if ($('#queuepausedcountergraph').length > 0) {

                    var d = new Date();
                    var n = d.getSeconds();
                    if(n==lastsecond) {
                        lastsecond=n;
                        return;
                    }
                    lastsecond=n;

                    window.dataqueuepausedcounter.shift();
                    window.dataqueuepausedcounter.push(currentpaused);
                    var res = [];
                    max=0;
                    for (var i = 0; i < window.dataqueuepausedcounter.length; ++i) {
                        res.push([i, window.dataqueuepausedcounter[i]]);
                        if(window.dataqueuepausedcounter[i]>max) { max = window.dataqueuepausedcounter[i]; }
                    }
                    if(max > maxy) {
                        maxy+=10;
                        plot = $.plot("#queuepausedcountergraph", [ res ], {
                            series: { shadowSize:0, lines: { show: true, fill: true, fillColor: { colors:[{ opacity: 0.9},{opacity: 0.1}]}} },
                            colors: ['#57889c'],
                            yaxis: { 'min': 0, 'max': maxy },
                            xaxis: { ticks: [[0,'5 min'],[60,'4 min'],[120,'3 min'],[180,'2 min'],[240,'1 min']], show: true }
                        });
                    } else if(max < (maxy - 10)) {
                        maxy-=10;
                        plot = $.plot("#queuepausedcountergraph", [ res ], {
                            series: { shadowSize:0, lines: { show: true, fill: true, fillColor: { colors:[{ opacity: 0.9},{opacity: 0.1}]}} },
                            colors: ['#57889c'],
                            yaxis: { 'min': 0, 'max': maxy },
                            xaxis: { ticks: [[0,'5 min'],[60,'4 min'],[120,'3 min'],[180,'2 min'],[240,'1 min']], show: true }
                        });
                    } else {
                        plot.setData([res]);
                        plot.draw();
                    }
                }
            } else {

                if(window.dataqueuepausedcounter.length == 0) {
                    for(a=0;a<300;a++) {
                       window.dataqueuepausedcounter[a]=0;
                    }
                }
                var res = [];
                for (var i = 0; i < window.dataqueuepausedcounter.length; ++i) {
                  res.push([i, window.dataqueuepausedcounter[i]])
                }

                if ($('#queuepausedcountergraph').length > 0) {
                    plot = $.plot("#queuepausedcountergraph", [ res ], {
                        series: { shadowSize:0, lines: { show: true, fill: true, fillColor: { colors:[{ opacity: 0.9},{opacity: 0.1}]}} },
                        colors: ['#57889c'],
                        yaxis: { 'min': 0, 'max': maxy },
                        xaxis: { ticks: [[0,'5 min'],[60,'4 min'],[120,'3 min'],[180,'2 min'],[240,'1 min']], show: true }
                    });

                    $("#queuepausedcountergraph").resizable({});
                }
            }
        },
        callback_zbuttons: function() {

            var oldclient=0;
            if ($('#box_asternicTagbox').length > 0) {
                oldclient=1;
            }

            if($('#box_queuepausedcounterbox').length<=0) {
               if (oldclient==1) {
                    var klon = $( '#box_asternicTagbox' );
                    var newklon = klon.clone().attr( { id: 'box_queuepausedcounterbox' }).css({display: 'block'}).insertBefore( klon );
                    newklon.find('*').each(function() {
                       if(typeof $(this).attr('id') == 'undefined') {
                       } else {
                           if($(this).attr('id')=='tagcall') { $(this).attr('id','queuepausedcountTitle').html(lang.queuepausedcounter); }
                           if($(this).attr('id')=='toggle-asternicTag') { $(this).attr('id','toggle-queuepausedcounter'); }
                           if($(this).attr('id')=='asternicTag') { $(this).attr('id','queuepausedcounter').css('text-align','center'); }
                       }
                    });
                } else {
                   // New bootstrap client
                   var newklon = $('<div class="grid-stack-item" id="box_queuepausedcounterbox" ><div class="grid-stack-item-content boxstyle boxstylebg"><div id="queuepausedcountercontent" class="widgetcontent widget widget-color"><header role="heading"><div class="widget-ctrls" role="menu"><a class="myclick button-icon widget-toggle-btn langcollapse" data-toggle="tooltip" rel="tooltip" title="" data-placement="bottom" data-original-title="Collapse"><i class="fa fa-caret-square-o-up"></i></a><a class="myclick button-icon widget-lock-btn langlockunlock" data-toggle="tooltip" rel="tooltip" title="" data-placement="bottom" data-original-title="Lock/Unlock"><i class="fa fa-unlock-alt"></i></a></div><span class="handle widget-icon"><i class="fa fa-bars"></i></span><h3><span id="queuepausedcountTitle">Agents Paused</span></h3></header><div class="widgetscroll" id="queuepausedcounterlist"><div id="queuepausedcounter" class="text-center" style="padding-top:5px;"><h1>0</h1></div><div id="queuepausedcountergraph" style="width:100%; height:150px;"></div></div></div></div>');
                   grid = $('.grid-stack').data('gridstack');

                   window.resizinggrid=1;
                   if(parseInt(currentrelease.replace(/\./g,''))>23101) {
                       grid.addWidget(newklon,0,0,3,6,true);
                   } else {
                       grid.add_widget(newklon,0,0,3,6,true);
                   }
                   window.resizinggrid=0;
           
                   $('#box_queuepausedcounterbox [data-toggle="tooltip"]').tooltip({container:'body'});
               }
            }

            if (oldclient==1) {
                makeSortable('right');

                if(typeof(mypreferences.rightColumnOrder)=='string') {
                    ordenarDiv('right_column',mypreferences.rightColumnOrder);
                }
            } else {
               window.resizinggrid=1;
               var jsongrid = Base64.decode(mypreferences.grid);
               if(jsongrid.length>0) {
                   try {
                       var dita = JSON.parse(jsongrid);
                       for (var item in dita) {
                           if(dita[item].id=='box_queuepausedcounterbox') {
                               grid.update($('#'+dita[item].id),dita[item].x,dita[item].y,dita[item].width,dita[item].height);
                           }
                       }
                   } catch(e) {
                       debug('Invalid JSON in grid pref');
                   }
               }
               window.resizinggrid=0;
            }

        },
        setExtensionMenu: function(items) {

            items.pause.disabled=false;

            if(min_available_threshold>0) {
                if(currentavailable <= min_available_threshold) {
                    if(typeof(items.pause)!=='undefined') {
                        items.pause.disabled=true;
                    }
                } 
            }

            if(max_paused_threshold>0) {
                if(currentpaused >= max_paused_threshold) {
                    if(typeof(items.pause)!=='undefined') {
                        items.pause.disabled=true;
                    }
                } 
            }

            for (var key in countreason) {
               if (countreason.hasOwnProperty(key)) {
                   if(typeof pluginconfig['queuepausedcounter']['max_paused_threshold'][key] !== 'undefined') {
                       if(countreason[key]>=pluginconfig['queuepausedcounter']['max_paused_threshold'][key] && pluginconfig['queuepausedcounter']['max_paused_threshold'][key]>0) {
                           items.pause.disabled=true;
                       } 
                   }
               }
            }

            return items;
        },
        disable_pauses: function() {
            //$('#presence').selectpicker('hide');
            var size = $('#presence option').size();
            for(i=1;i<size;i++) {
                $('#presence option:eq('+i+')').attr('disabled','disabled');
            }
            $('.selectpicker').selectpicker('refresh');


        },
        disable_reason: function(reason) {
            //$('#presence').selectpicker('hide');
            console.log(reason);
            var size = $('#presence option').size();
            for(i=1;i<size;i++) {
                if($('#presence option:eq('+i+')').val()==reason) {
                    $('#presence option:eq('+i+')').attr('disabled','disabled');
                }
            }
            $('.selectpicker').selectpicker('refresh');


        },
 
        enable_pauses: function() {
            //$('#presence').selectpicker('show');
            var size = $('#presence option').size();
            for(i=1;i<size;i++) {
                $('#presence option:eq('+i+')').removeAttr('disabled');
            }
            $('.selectpicker').selectpicker('refresh');
        },
        calculate_paused:  function() {
            agents_paused = {};
            agents_pausedinvalid = {};
            agents_total  = {};
            $('.memberpaused').each(function() {
               chan   = $(this).data('channel').split('~')[2];
               reason = $(this).attr('data-original-title').split(': ')[1];
               if(typeof reason == 'undefined') { reason=''; }
               agents_paused[chan]=reason;
            });
            $('.memberpausedinvalid').each(function() {
               chan   = $(this).data('channel').split('~')[2];
               reason = $(this).attr('data-original-title').split(': ')[1];
               if(typeof reason == 'undefined') { reason=''; }
               agents_pausedinvalid[chan]=reason;
            });
            $('.memberbusypaused').each(function() {
               chan   = $(this).data('channel').split('~')[2];
               reason = $(this).attr('data-original-title').split(': ')[1];
               if(typeof reason == 'undefined') { reason=''; }
               agents_paused[chan]=reason;
            });
            $('.ctxmenuqueue').each(function() { agents_total[$(this).data('channel').split('~')[2]]=1;});

            currentpaused = Object.keys(agents_paused).length;

            if(ignore_invalid_agents==1) {
                currentpaused = Object.keys(agents_paused).length - Object.keys(agents_pausedinvalid).length;
            }

            currenttotal  = Object.keys(agents_total).length;
            currentavailable = currenttotal - currentpaused;
            if(currentavailable <= 0 ){ currentavailable = 0; }

            $('#queuepausedcounter').html('<h1>'+currentpaused+'</h1>');

            countreason={};
            for (var key in agents_paused) {
               if (agents_paused.hasOwnProperty(key)) {
                  if(typeof countreason[agents_paused[key]] === 'undefined') { countreason[agents_paused[key]]=0; }
                  countreason[agents_paused[key]]++;
               }
            }

            plugins['queuepausedcounter'].enable_pauses();

            for (var key in countreason) {
               if (countreason.hasOwnProperty(key)) {
                   if(key!='') {
                       if(typeof pluginconfig['queuepausedcounter']['max_paused_threshold'][key] !== 'undefined') {
                           if(countreason[key]>=pluginconfig['queuepausedcounter']['max_paused_threshold'][key]) {
                               plugins['queuepausedcounter'].disable_reason(key);
                           } 
                       }
                   }
               }
            }

            if(min_available_threshold>0) {
                if(currentavailable <= min_available_threshold) {
                    plugins['queuepausedcounter'].disable_pauses();
                } 
            }

            if(max_paused_threshold>0) {
                if(currentpaused >= max_paused_threshold) {
                    plugins['queuepausedcounter'].disable_pauses();
                } 
            }
 
        },
        callback_queuemembers: function(nro,texto,slot) {
            plugins['queuepausedcounter'].calculate_paused();
        },
        callback_queuemember: function(nro,texto,slot) {
            plugins['queuepausedcounter'].calculate_paused();
        }
    }
}());
